Bug 214849 - Eclipse crashes during source code editing
Eclipse crashes during source code editing
Status: CLOSED INSUFFICIENT_DATA
Product: Fedora
Classification: Fedora
Component: eclipse (Show other bugs)
6
i386 Linux
low Severity high
: ---
: ---
Assigned To: Andrew Overholt
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2006-11-09 13:45 EST by Kim van der Riet
Modified: 2007-11-30 17:11 EST (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2007-02-06 13:57:45 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Config file (142.47 KB, text/plain)
2006-11-09 13:45 EST, Kim van der Riet
no flags Details
log file (418.14 KB, text/plain)
2006-11-09 13:49 EST, Kim van der Riet
no flags Details

  None (edit)
Description Kim van der Riet 2006-11-09 13:45:25 EST
Description of problem:
During normal editing usage (i.e. while editing/typing Java source code),
Eclipse exits without warning, and shows a simple dialog containing the
following message:

JVM terminated. Exit code=1
/usr/bin/java
-jar startup.jar
-os linux
-ws gtk
-arch x86
-launcher /usr/bin/eclipse
-name Eclipse
-showsplash 600
-exitdata 1c6001f
-vm /usr/bin/java
-vmargs
-jar startup.jar

All unsaved edits are lost. The crash happens after an hour or two of usage; I
have had two today (so far) and two yesterday - the day I started using Eclipse
on FC6.

Version-Release number of selected component (if applicable):
Version: 3.2.0
Build id: M20060921-0945 (Fedora Core release 5.92 (FC6 Test3))

How reproducible:
No specific steps have been detected.
Approximation:
1. Start Eclipse
2. Edit Java files for several hours.
  

Additional info:
Eclipse is running on Sun's java:
java version "1.5.0_09"
Java(TM) 2 Runtime Environment, Standard Edition (build 1.5.0_09-b03)
Java HotSpot(TM) Client VM (build 1.5.0_09-b03, mixed mode, sharing)

I used the alternatives program to switch java and javac to this version:
[root@busy-beaver ~]# alternatives --display java
java - status is auto.
 link currently points to /usr/java/jdk1.5.0_09/bin/java
/usr/lib/jvm/jre-1.4.2-gcj/bin/java - priority 1420
 slave keytool: /usr/lib/jvm/jre-1.4.2-gcj/bin/keytool
 slave rmiregistry: /usr/lib/jvm/jre-1.4.2-gcj/bin/rmiregistry
 slave jre_exports: /usr/lib/jvm-exports/jre-1.4.2-gcj
 slave jre: /usr/lib/jvm/jre-1.4.2-gcj
/usr/java/jdk1.5.0_09/bin/java - priority 2048
 slave keytool: (null)
 slave rmiregistry: (null)
 slave jre_exports: (null)
 slave jre: (null)
Current `best' version is /usr/java/jdk1.5.0_09/bin/java.
Comment 1 Kim van der Riet 2006-11-09 13:45:25 EST
Created attachment 140804 [details]
Config file
Comment 2 Kim van der Riet 2006-11-09 13:49:38 EST
Created attachment 140805 [details]
log file

Crashes happened today and yesterday (11/9 and 11/8).
Comment 3 Kim van der Riet 2006-11-10 09:11:01 EST
Again, as I pressed the Enter key to start a new line while editing a Java
source file. This time, exitdata 2360020, log's last entry was at startup, so
nothing written or was lost on exit. I had been working for nearly 2 hours.

Sorry that this problem seems so difficult to pinpoint... I realise that this is
poor bug information. If some additional guidance is given to help narrow the
problem, I am willing to help.
Comment 4 Ben Konrath 2006-11-10 12:06:59 EST
I notice that you're switching between Sun's VM and GCJ. If this is happening
with the Sun VM, there's not a lot I can do to help. Using a proprietary VM is
not supported on Fedora. Sorry. 

One thing you could try is to load the embedded browswer when you're using the
Sun VM. We have a patch in SWT to fix a crasher bug like this with GCJ and I'm
wondering if that's causing this problem with the Sun VM.

Another thing you could do is run eclipse from the commandline with the
'-consolelog' option. That way when eclipse crashes you can paste the output
here even if it doesn't get written to the log file.
Comment 5 Kim van der Riet 2006-11-10 14:55:20 EST
Using the -consolelog option you suggested, I got after two and a half hours:

The program 'Gecko' received an X Window System error.
This probably reflects a bug in the program.
The error was 'BadRequest (invalid request code or no such operation)'.
  (Details: serial 8774706 error_code 1 request_code 0 minor_code 0)
  (Note to programmers: normally, X errors are reported asynchronously;
   that is, you will receive the error a while after causing it.
   To debug your program, run it with the --sync command line
   option to change this behavior. You can then get a meaningful
   backtrace from your debugger if you break on the gdk_x_error() function.)

Unfortunately, I'm working on a project that requires the Sun VM, hence the
change of VM from gcj.
Comment 6 Andrew Overholt 2006-11-14 11:54:10 EST
(In reply to comment #5)
> Using the -consolelog option you suggested, I got after two and a half hours:
> 
> The program 'Gecko' received an X Window System error.

This looks like a problem with the embedded web browser.  Are you running on
stock FC6?  We've had to patch the embedded browser to work with the firefox
builds we have in Fedora.  I don't know if an upstream firefox download will work.

> Unfortunately, I'm working on a project that requires the Sun VM, hence the
> change of VM from gcj.

Can I ask what features it requires in the Sun VM?  Perhaps something can be
done to fix this in the short term.
Comment 7 Ben Konrath 2006-11-14 12:28:35 EST
Andrew, I'm handing this bug over to you since you wrote the patch. Thanks.
Comment 8 Kim van der Riet 2006-11-14 13:21:45 EST
> This looks like a problem with the embedded web browser.  Are you running on
> stock FC6?  We've had to patch the embedded browser to work with the firefox
> builds we have in Fedora.  I don't know if an upstream firefox download will
> work.
FC6-gold-i386 installed from the RH Intranet and updatad by pup to the latest: 
2.6.18-1.2849.fc6; firefox-1.5.0.8-1.fc6

> Can I ask what features it requires in the Sun VM?  Perhaps something can be
> done to fix this in the short term.
The project is a part of Qpid, an implementation of the Advanced Messaging and
Queues Protocol (AMQP), both server and client. GCJ currently does not support
all the features we require for the project.

As these crashes were getting in the way of my work, I have uninstalled Fedora's
Eclipse and installed the upstream version directly from Eclipse - it seems to
work fine under otherwise identical conditions. If you require help with
debugging this issue, I am willing to reinstall.
Comment 9 Andrew Overholt 2006-11-14 13:32:29 EST
Thanks for the offer to reinstall.  Unfortunately since you're the only one I've
seen with these problems, I can't think of how we can proceed.  If we get other
reports, perhaps we can investigate more.  I am surprised, though, since I have
personally used the Sun VM with our installed packages and never had a problem.

Can you elaborate on "GCJ currently does not support all the features we require
for the project"?  I don't doubt this, I'm just curious to know which features.
Comment 10 Kim van der Riet 2006-11-14 14:08:09 EST
On reflection, there is one aspect in which my installation is *not* vanilla
(apart from the Sun JVM) - I'm using Nvidia's display drivers. It works
flawlessly in all apps and openGL screensavers, etc, so it seems unlikely that
this would be a factor - but I know enough to know that I can never be sure!
Comment 11 Andrew Overholt 2006-11-14 14:18:11 EST
(In reply to comment #10)
> On reflection, there is one aspect in which my installation is *not* vanilla
> (apart from the Sun JVM) - I'm using Nvidia's display drivers. It works
> flawlessly in all apps and openGL screensavers, etc, so it seems unlikely that
> this would be a factor - but I know enough to know that I can never be sure!

Yeah, this seems unlikely but it's hard to say for sure.  I'm really sorry I
can't think of any way to go further tracking this down.  Let's leave it open
and if we can think of anything else or if more information comes to light,
we'll put it here.
Comment 12 Ben Konrath 2006-11-14 14:20:49 EST
If you have time and it's not too hard, would you be able to try eclipse with
Sun's VM without the Nvidia drivers? It's really just a shot in the dark but it
would be nice to eliminate that variable. Thanks.
Comment 13 Kim van der Riet 2006-11-15 07:56:12 EST
<sarcastic> Good news... </sarcastic>

I reinstalled the Fedora eclipse alongside the upstream version. Since the
upstream version is nicely contained in /usr/local/eclipse (where I put it),
there seems to be no interaction between it and the Fedora version. I ran the
Fedora version again, and once again, it crashed after an hour or two of use:
"The program 'Eclipse' received an X Window System error."

This means that I still have a (vaguely) reproducable error.

It may be worth mentioning (again, because X is involved, and determining the
relevance of these things is difficult) that there are two X screens in play: I
am useing the dual-head feature of the Quadro card to run two displays
configured as independent displays: :0.0 and :0.1.

I'll look at reinstating the built-in video drivers later today. I am not
certain whether these drivers will be able to support two displays in the same way.
Comment 14 Ben Konrath 2006-11-22 16:43:29 EST
Changing priority to low because we can't debug issues with closed source software.
Comment 15 Kim van der Riet 2006-11-27 07:40:14 EST
I have been unable so far to decouple the video driver from the crash. I used
the built-in (Fedora) nv drivers for 2 days without a crash. However, I was
unable to sucsessfully configure my second screen to work with this dirver (I
keep getting unexplained X errors on startup). Owing to the fact that I need the
second screen, I switched back to using Nvidia's drivers, and *BANG* - Eclipse
crashed again.

Although not proof, there seems to be a circumstantial link between Nvidia's
driver and this crash. The only remaining difference between the scenarios which
needs to be eliminated is the number of screens, but this seems to be unlikely
on the face of it. I will need to solve the configuration problems with the nv
driver to complete this.

In the meantime, I will revert to using the upstream Eclipse, which does not
share this problem.
Comment 16 Andrew Overholt 2006-11-27 09:03:37 EST
The nv driver doesn't support multiple heads AFAIK.
Comment 17 Matthew Priors 2006-12-06 10:20:24 EST
3 of us in my office have the same issue. The issue has been around for all
x86_64 and xen kernels that we have had installed.

We have Ati cards in our machines and are running dual screen setups using the
ati drivers packaged up by the linva repo.
We are also using java 1.5 sun as gcj doesn't run our code.

I have also seen this same issue a couple of times on my home PC which is
FC6/nvidia/linva drivers/single screen/sun java 1.5.
Comment 18 Andrew Overholt 2006-12-06 10:28:01 EST
So it appears that this is some sort of issue with proprietary video drivers? 
That seems odd.  CCing ajax to get his opinion.
Comment 19 Ben Konrath 2007-02-06 13:57:45 EST
Since this issue deals with code that we don't have the source to debug, I'm
closing this bug. 

Note You need to log in before you can comment on or make changes to this bug.